set echo on
set termout on
set linesize 110
set pagesize 1000
set trimspool on

spool indexsuppresion.log

select * from v$version;

-- create table with number column and index on that column
-- use dba_objects

drop table test;

create table test as select * from dba_objects;

desc test;

create index testindex on test (object_id);

exec dbms_stats.gather_table_stats(NULL,'TEST');

-- uses index when object_id compared to number

select owner,object_type,object_name
from test 
where
object_id = 2;

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

-- uses index when object_id compared to string

select owner,object_type,object_name
from test 
where
object_id = '2';

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

-- does not use index when object_id compared to string with like

select owner,object_type,object_name
from test 
where
object_id like '2';

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

-- function based index is used with like

create index testindex2 on test (to_char(object_id));

select owner,object_type,object_name
from test 
where
object_id like '2';

select * from table(dbms_xplan.display_cursor(null,null,'ALL'));

spool off
